
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>解决Android解析图片的OOM问题!!! / iVAN</title>

    <meta name="description" content="解决Android解析图片的OOM问题!!! 大家好,今天给大家分享的是解决解析图片的出现oom的问题,我们可以用BitmapFactory这里的各种Decode方法,如果图片很小的话,不会出现oom,但是当图片很大的时候 就要用BitmapFactory.Options这个东东了,Options里主要有两个参数比较重要. options.inJustDecodeBounds = false/true; //图片压缩比例. options.inSampleSize = ssize; 我们去解析一个图片,如果太大,就会OOM,我们可以设置压缩">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">解决Android解析图片的OOM问题!!!</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>大家好，今天给大家分享的是解决解析图片的出现oom的问题，我们可以用BitmapFactory这里的各种Decode方法，如果图片很小的话，不会出现oom,但是当图片很大的时候<br />
就要用BitmapFactory.Options这个东东了,Options里主要有两个参数比较重要.</p>
<pre></pre>
<ol>
<li>options.inJustDecodeBounds = false/true;</li>
<li>//图片压缩比例.</li>
<li>options.inSampleSize = ssize;</li>
</ol>
<p>我们去解析一个图片，如果太大，就会OOM，我们可以设置压缩比例inSampleSize,但是这个压缩比例设置多少就是个问题，所以我们解析图片可以分为俩个步骤，第一步就是</p>
<p>获取图片的宽高，这里要设置Options.inJustDecodeBounds=true,这时候decode的bitmap为null,只是把图片的宽高放在Options里，然后第二步就是设置合适的压缩比例inSampleSize，这时候获得合适的Bitmap.这里我画了简单的流程图，如下<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYTEuZW9lLmNuL3d3dy9ob21lLzIwMTMwMi8yMS9kZjNhLzUxMjVlYzdmZTU4YTcuanBn.jpg"><br />
为了让大家更容易理解，我这里做了一个简单的demo,主要功能就是一个界面里有个ImageView,点击ImageView的时候，进入本地相册，选择一个图片的时候，ImageView控件显示选择的图片。Demo的步骤如下：</p>
<p>第一步新建一个Android工程命名为ImageCacheDemo.目录结构如下：<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYTEuZW9lLmNuL3d3dy9ob21lLzIwMTMwMi8yMS8yZThmLzUxMjVlYzk0MDZhM2MuanBn.jpg"><br />
第二步新建一个ImageCacheUtil.java工具类，代码如下：</p>
<pre></pre>
<ol>
<li>package com.tutor.oom;</li>
<li>import java.io.InputStream;</li>
<li>import android.content.ContentResolver;</li>
<li>import android.content.Context;</li>
<li>import android.graphics.Bitmap;</li>
<li>import android.graphics.BitmapFactory;</li>
<li>import android.graphics.BitmapFactory.Options;</li>
<li>import android.net.Uri;</li>
<li>/**</li>
<li>* @author frankiewei.</li>
<li>* 工具类.</li>
<li>*/</li>
<li>public class ImageCacheUtil {</li>
<li>/**</li>
<li>* 获取合适的Bitmap平时获取Bitmap就用这个方法吧.</li>
<li>* @param path 路径.</li>
<li>* @param data byte[]数组.</li>
<li>* @param context 上下文</li>
<li>* @param uri uri</li>
<li>* @param target 模板宽或者高的大小.</li>
<li>* @param width 是否是宽度</li>
<li>* @return</li>
<li>*/</li>
<li>public static Bitmap getResizedBitmap(String path, byte[] data,</li>
<li>Context context,Uri uri, int target, boolean width) {</li>
<li>Options options = null;</li>
<li>if (target &gt; 0) {</li>
<li>Options info = new Options();</li>
<li>//这里设置true的时候，decode时候Bitmap返回的为空，</li>
<li>//将图片宽高读取放在Options里.</li>
<li>info.inJustDecodeBounds = false;</li>
<li>decode(path, data, context,uri, info);</li>
<li>int dim = info.outWidth;</li>
<li>if (!width)</li>
<li>dim = Math.max(dim, info.outHeight);</li>
<li>int ssize = sampleSize(dim, target);</li>
<li>options = new Options();</li>
<li>options.inSampleSize = ssize;</li>
<li>}</li>
<li>Bitmap bm = null;</li>
<li>try {</li>
<li>bm = decode(path, data, context,uri, options);</li>
<li>} catch(Exception e){</li>
<li>e.printStackTrace();</li>
<li>}</li>
<li>return bm;</li>
<li>}</li>
<li>/**</li>
<li>* 解析Bitmap的公用方法.</li>
<li>* @param path</li>
<li>* @param data</li>
<li>* @param context</li>
<li>* @param uri</li>
<li>* @param options</li>
<li>* @return</li>
<li>*/</li>
<li>public static Bitmap decode(String path, byte[] data, Context context,</li>
<li>Uri uri, BitmapFactory.Options options) {</li>
<li>Bitmap result = null;</li>
<li>if (path != null) {</li>
<li>result = BitmapFactory.decodeFile(path, options);</li>
<li>} else if (data != null) {</li>
<li>result = BitmapFactory.decodeByteArray(data, 0, data.length,</li>
<li>options);</li>
<li>} else if (uri != null) {</li>
<li>//uri不为空的时候context也不要为空.</li>
<li>ContentResolver cr = context.getContentResolver();</li>
<li>InputStream inputStream = null;</li>
<li>try {</li>
<li>inputStream = cr.openInputStream(uri);</li>
<li>result = BitmapFactory.decodeStream(inputStream, null, options);</li>
<li>inputStream.close();</li>
<li>} catch (Exception e) {</li>
<li>e.printStackTrace();</li>
<li>}</li>
<li>}</li>
<li>return result;</li>
<li>}</li>
<li>/**</li>
<li>* 获取合适的sampleSize.</li>
<li>* 这里就简单实现都是2的倍数啦.</li>
<li>* @param width</li>
<li>* @param target</li>
<li>* @return</li>
<li>*/</li>
<li>private static int sampleSize(int width, int target){</li>
<li>int result = 1;</li>
<li>for(int i = 0; i &lt; 10; i++){</li>
<li>if(width &lt; target * 2){</li>
<li>break;</li>
<li>}</li>
<li>width = width / 2;</li>
<li>result = result * 2;</li>
<li>}</li>
<li>return result;</li>
<li>}</li>
<li>}</li>
</ol>
<p>第三步：修改ImageCacheDemoActivity.java代码如下：
<pre></pre>
<ol>
<li>package com.tutor.oom;</li>
<li>import android.app.Activity;</li>
<li>import android.content.Intent;</li>
<li>import android.graphics.Bitmap;</li>
<li>import android.os.Bundle;</li>
<li>import android.provider.MediaStore;</li>
<li>import android.view.View;</li>
<li>import android.view.View.OnClickListener;</li>
<li>import android.widget.ImageView;</li>
<li>/**</li>
<li>* @author frankiewei.</li>
<li>* 解决图片普通OOM的Demo.</li>
<li>*/</li>
<li>public class ImageCacheDemoActivity extends Activity {</li>
<li>/**</li>
<li>* 显示图片的ImageView.</li>
<li>*/</li>
<li>private ImageView mImageView;</li>
<li>/**</li>
<li>* 打开本地相册的requestcode.</li>
<li>*/</li>
<li>public static final int OPEN_PHOTO_REQUESTCODE =  0x1;</li>
<li>/**</li>
<li>* 图片的target大小.</li>
<li>*/</li>
<li>private static final int target = 400;</li>
<li>@Override</li>
<li>public void onCreate(Bundle savedInstanceState) {</li>
<li>super.onCreate(savedInstanceState);</li>
<li>setContentView(R.layout.main);</li>
<li>setupViews();</li>
<li>}</li>
<li>private void setupViews(){</li>
<li>mImageView = (ImageView)findViewById(R.id.imageview);</li>
<li>mImageView.setOnClickListener(new OnClickListener() {</li>
<li>public void onClick(View v) {</li>
<li>openPhotos();</li>
<li>}</li>
<li>});</li>
<li>}</li>
<li>/**</li>
<li>* 打开本地相册.</li>
<li>*/</li>
<li>private void openPhotos() {</li>
<li>Intent intent = new Intent(Intent.ACTION_PICK, null);</li>
<li>intent.setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI,</li>
<li>"image/*");</li>
<li>startActivityForResult(intent, OPEN_PHOTO_REQUESTCODE);</li>
<li>}</li>
<li>@Override</li>
<li>protected void onActivityResult(int requestCode, int resultCode, Intent data) {</li>
<li>switch (requestCode) {</li>
<li>case OPEN_PHOTO_REQUESTCODE:</li>
<li>if(resultCode == RESULT_OK){</li>
<li>//如果用这个方法，Options为null时候，就是默认decode会出现oom哦.</li>
<li>//Bitmap bm = ImageCacheUtil.decode(null, null,</li>
<li>//      ImageCacheDemoActivity.this, data.getData(), null);</li>
<li>//这里调用这个方法就不会oom.屌丝们就用这个方法吧.</li>
<li>Bitmap bm = ImageCacheUtil.getResizedBitmap(null, null,</li>
<li>ImageCacheDemoActivity.this, data.getData(), target, false);</li>
<li>mImageView.setImageBitmap(bm);</li>
<li>}</li>
<li>break;</li>
<li>default:</li>
<li>break;</li>
<li>}</li>
<li>super.onActivityResult(requestCode, resultCode, data);</li>
<li>}</li>
<li>}</li>
<li> </li>
<li>package com.tutor.oom;</li>
<li> </li>
<li>import android.app.Activity;</li>
<li>import android.content.Intent;</li>
<li>import android.graphics.Bitmap;</li>
<li>import android.os.Bundle;</li>
<li>import android.provider.MediaStore;</li>
<li>import android.view.View;</li>
<li>import android.view.View.OnClickListener;</li>
<li>import android.widget.ImageView;</li>
<li> </li>
<li>/**</li>
<li>* @author frankiewei.</li>
<li>* 解决图片普通OOM的Demo.</li>
<li>*/</li>
<li>public class ImageCacheDemoActivity extends Activity {</li>
<li>/**</li>
<li>* 显示图片的ImageView.</li>
<li>*/</li>
<li>private ImageView mImageView;</li>
<li>/**</li>
<li>* 打开本地相册的requestcode.</li>
<li>*/</li>
<li>public static final int OPEN_PHOTO_REQUESTCODE =  0x1;</li>
<li>/**</li>
<li>* 图片的target大小.</li>
<li>*/</li>
<li>private static final int target = 400;</li>
<li>@Override</li>
<li>public void onCreate(Bundle savedInstanceState) {</li>
<li>super.onCreate(savedInstanceState);</li>
<li>setContentView(R.layout.main);</li>
<li>setupViews();</li>
<li>}</li>
<li>private void setupViews(){</li>
<li>mImageView = (ImageView)findViewById(R.id.imageview);</li>
<li>mImageView.setOnClickListener(new OnClickListener() {</li>
<li>public void onClick(View v) {</li>
<li>openPhotos();</li>
<li>}</li>
<li>});</li>
<li>}</li>
<li>/**</li>
<li>* 打开本地相册.</li>
<li>*/</li>
<li>private void openPhotos() {</li>
<li> </li>
<li>Intent intent = new Intent(Intent.ACTION_PICK, null);</li>
<li>intent.setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI,</li>
<li>"image/*");</li>
<li> </li>
<li>startActivityForResult(intent, OPEN_PHOTO_REQUESTCODE);</li>
<li> </li>
<li>}</li>
<li>@Override</li>
<li>protected void onActivityResult(int requestCode, int resultCode, Intent data) {</li>
<li>switch (requestCode) {</li>
<li>case OPEN_PHOTO_REQUESTCODE:</li>
<li>if(resultCode == RESULT_OK){</li>
<li>//如果用这个方法，Options为null时候，就是默认decode会出现oom哦.</li>
<li>//Bitmap bm = ImageCacheUtil.decode(null, null,</li>
<li>//		ImageCacheDemoActivity.this, data.getData(), null);</li>
<li>//这里调用这个方法就不会oom.屌丝们就用这个方法吧.</li>
<li>Bitmap bm = ImageCacheUtil.getResizedBitmap(null, null,</li>
<li>ImageCacheDemoActivity.this, data.getData(), target, false);</li>
<li>mImageView.setImageBitmap(bm);</li>
<li>}</li>
<li>break;</li>
<li> </li>
<li>default:</li>
<li>break;</li>
<li>}</li>
<li>super.onActivityResult(requestCode, resultCode, data);</li>
<li>}</li>
<li>}</li>
</ol>
<p>其中main.xml布局代码如下：</p>
<pre></pre>
<ol>
<li>&lt;TextView</li>
<li>android:layout_width="fill_parent"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:text="@string/hello" /&gt;</li>
<li>&lt;ImageView</li>
<li>android:id="@+id/imageview"</li>
<li>android:layout_width="400px"</li>
<li>android:layout_height="400px"</li>
<li>android:src="@drawable/ic_launcher"</li>
<li>/&gt;</li>
<li> </li>
<li>&lt;/LinearLayout&gt;</li>
</ol>
<p>第四步运行上述工程，效果如下：<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYTEuZW9lLmNuL3d3dy9ob21lLzIwMTMwMi8yMS80YTJhLzUxMjVlY2ZiYmMwZTguanBn.jpg"><br />从本地相册选择显示。用了getRsizedBitmap()方法，图片很大不会oom.<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYTEuZW9lLmNuL3d3dy9ob21lLzIwMTMwMi8yMS8yODQ0LzUxMjVlZDBiZTdiY2IuanBn.jpg"></p>
<p>运用默认的decode方法就会oom。</p>
<p>原文地址： <a href="http://my.eoe.cn/androidtutor/archive/927.html" rel="external nofollow noreferrer">http://my.eoe.cn/androidtutor/archive/927.html</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:32:10</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>解决Android解析图片的OOM问题!!!的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44J5Lz.html" rel="bookmark">解决Android解析图片的OOM问题的方法&excl;&excl;&excl;&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家好,今天给大家分享的是解决解析图片的出现oom的问题,我们可以用BitmapFactory这里的各种Decode方法,如果图片很小的话,不会出现oom,但是当图片很大的时候 就要用BitmapFactory.Options这个东东了,Options里主要有两个参数比较重要. options.inJustDecodeBounds = false/true; //图片压缩比例. options.inSampleSize = ssize; 我们去解析一个图片,如果太大,就会OOM,我们可以设置压缩			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p56aO6z.html" rel="bookmark">解决Android解析图片的OOM问题的方法&excl;&excl;&excl;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家好,今天给大家分享的是解决解析图片的出现oom的问题,我们可以用BitmapFactory这里的各种Decode方法,如果图片很小的话,不会出现oom,但是当图片很大的时候 就要用BitmapFactory.Options这个东东了,Options里主要有两个参数比较重要. options.inJustDecodeBounds = false/true; //图片压缩比例. options.inSampleSize = ssize; 我们去解析一个图片,如果太大,就会OOM,我们可以设置压缩			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyWgOlz.html" rel="bookmark">解决Android从相册中获取图片出错图片却无法裁剪问题的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在学习获取相册中图片进行裁剪的时候遇到了比较大的问题,在纠结了近半天才真的解决,下面分享一下学习经验. 问题: 选择了相册中的图片之后要进入图片裁剪的时候出错,(华为)手机提示&quot;此图片无法获取&quot;,经百度后,明白是版本不同导致的URI的问题的问题,原文如下: 4.3或以下,选了图片之后,根据Uri来做处理,很多帖子都有了,我就不详细说了.主要是4.4,如果使用上面pick的原生方法来选图,返回的uri还是正常的,但如果用ACTION_GET_CONTENT的方法,返回的uri跟4.3是完			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXwdWQM.html" rel="bookmark">我在android中集成了mupdf，但图文混排的pdf不能解析图片，只显示了文字</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我在android中集成了mupdf,但图文混排的pdf不能解析图片,只显示了文字 你好,我用官方的 .so 文件,集成到android里面,现在能打开pdf文件,可是图文混排的图全部没有了,只有文字解析,而且没有很好的适应一页,明显下面还有文字没有显示,请指教 另外解析了一个xps文件,结果格式完全不对,图片还漂移 请指教,谢谢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBg654M.html" rel="bookmark">解决android手机安装包频繁提示解析错误方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android操作系统作为目前唯一可以与苹果iOS系统平分秋色的一款新生系统,它之所以成长的如此之快,除了其很强的开源性,Android系统一个很大的优势就在于其海量增长的应用程序.一款好玩的应用程序是充实闲暇时光的一柄利器,当我们新入手一款Android手机,慢慢熟悉后或多或少都会想到丰富其内置的应用程序,看到好玩的游戏或软件都会想要下载安装.而如果大家的Android手机在安装apk程序途中弹出&quot;解析包时出现问题&quot;这样的提示,会不会觉得很揪心呢?那么Android解析包出现问题有没			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvnLx6M.html" rel="bookmark">图片下载 图片缓存-android下载图片保存到本地图片大小为0KB，是什么原因？？求大神解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android下载图片保存到本地图片大小为0KB,是什么原因??求大神解决 public Drawable loadImageFromUrl(String urlPath, String directory, String filename) { byte[] data = null; InputStream is = null; Drawable drawable = null; HttpURLConnection conn = null; URL url = null; try {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRw09qp.html" rel="bookmark">Android内存优化之OOM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://www.csdn.net/article/2015-09-18/2825737/1 10月14日-16日,由CSDN和创新工场联合主办的MDCC 2015中国移动开发者大会将在北京新云南皇冠假日酒店隆重召开,现在抢注大会门票,即享多重好礼!在平台与技术iOS专场议题全方位揭秘之后,平台与技术Android专场也有新动作!与会讲师--腾讯Android应用开发工程师 胡凯围绕着&quot;Android内存优化之OOM&quot;进行了非常深度的技术分享.   腾讯Android应用开发			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRywkp.html" rel="bookmark">android studio-如何解决Android studio内存不够用的问题？（我放了2张静态图和一张gif图，代码都没错）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如何解决Android studio内存不够用的问题?(我放了2张静态图和一张gif图,代码都没错) (怎么释放android的内存,如何让Bitmap调用recycle()...) 08-27 01:51:37.454 18923-18923/com.haoming.hm_xzt.app E/art﹕ Throwing OutOfMemoryError &quot;Failed to allocate a 582912 byte allocation with 75624 free bytes			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKdmGLM.html" rel="bookmark">OkHttp框架从入门到放弃，解析图片使用Picasso裁剪，二次封装OkHttpUtils，Post提交表单数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OkHttp框架从入门到放弃,解析图片使用Picasso裁剪,二次封装OkHttpUtils,Post提交表单数据 我们这片博文就来聊聊这个反响很不错的OkHttp了,标题是我恶搞的,本篇将着重详细的分析,探索OkHttp这个框架的使用和封装 一.追其原理 Android系统提供了两种HTTP通信类 HttpURLConnection HttpClient Google推荐使用HttpURLConnection,这个没必要多说,事实上,我这篇写的应该算是比较晚了,很多优秀的博文都已经提出了这些观			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9ze7dwM.html" rel="bookmark" class="title">输入标准的简写中文数字&OpenCurlyDoubleQuote;&cir;&rdquo;的6种方法</a>
					<div>
						根据我国公文写作规定,时间落款的年月日应是简写的汉字数字,而不是汉字与阿拉伯数字混用,更不是汉字与英文的混用.但在实际写作时总是容易把日期写成类似&quot;二00年&quot;(数字0)或&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0LEAM.html" rel="bookmark" class="title">JavaBean操作Oracle数据库</a>
					<div>
						oracle|数据|数据库 本文以一个完整的JavaBean数据库访问程序简要说明jsp操作数据库.  本程序由3个bean组成,其中WebConstants中定义全局变量,ConnectionMan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJl14M.html" rel="bookmark" class="title">如何用C&num;显示竖排文字？</a>
					<div>
						显示   看这个题目,应该觉的这个问题不难,刚开始我也是这么想,可是目前我手头上的参考资料上没有一个介绍竖直显示文字的,上网查资料只发现一个有用的,可是实现起来比较麻烦,需要进行坐标转换,旋转,还得平 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPjqrb.html" rel="bookmark" class="title">Fireworks 创建残破纹理特效文字</a>
					<div>
						创建|特效 前面我们介绍了Fireworks 创建残破纹理背景,其实文字也可以做类似的残缺特效处理,下面我们看看具体步骤. 我们在Fireworks新建一个文件,打字,字号选大些,做成后的效果才会更明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7Vlqp.html" rel="bookmark" class="title">做网站优化SEO应该具备的三种能力心态</a>
					<div>
						可以说SEO心态千万不要浮躁,如果,你的心态浮躁的话,是做不好SEO的.为什么这么说.因为,有的时候,做SEO缺的就是心态,缺的就是让你感受他的细节所在.现在很多人,也许随着都市生活结构的加快,心也变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7gKdM.html" rel="bookmark" class="title">使用JMX监控应用程序内、外部的状况</a>
					<div>
						Java管理API (JMX)对管理WebLogic服务器而言是必需的.通过这个API,你可以在应用程序服务器里搜索管理beans (mbeans) 并且通过它们你既可以查询配置信息又可以查询runt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7OO2M.html" rel="bookmark" class="title">PS合成飞奔的水马技巧</a>
					<div>
						制作水马跟水人的方法类似.主要有两个大的步骤:首先需要把马用仿制图章等工具去掉,背景处理越干净效果越逼真.然后按照马的轮廓,用水花素材等叠加上去,局部调整好大小.后期再微调细节,渲染颜色即可. 最终效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8NQAp.html" rel="bookmark" class="title">Photoshop保留质感给人像进行磨皮</a>
					<div>
						原图: 效果图: 操作步骤: 1.打开图像并放大后,可以发现人物具有很好的皮肤纹理. 2.拷贝图层. 3.执行高斯模糊滤镜命令(这里实际上不会模糊皮肤,我们只是使用这个对话框替我们做计算,这在另一个对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0W7mmb.html" rel="bookmark" class="title">玩游戏经常闪屏解决参考</a>
					<div>
						  最近小子我一玩游戏就闪屏,大家如果有这种问题可以先看看这个是不是重装系统后或怎么的,设置改变了,刷新频率太低了而导致的. 如果低了调高点,在图片第5步的地方点击有个下拉菜单,可以调高点,再进游戏看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42Eq8M.html" rel="bookmark" class="title">第5章&lpar;3&rpar; 初始化</a>
					<div>
						所有成员都要初始化: 1. Java尽力保证所有变量都能在使用前得到正确的初始化.若被定义成相对于一个方法的&quot;局部&quot;变量,这一保证就通过编译期的出错提示表现出来. 2. 基本类型的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7YN2z.html" rel="bookmark" class="title">弹出窗口及关闭总结（window&period;open&lpar;&rpar;&semi;Response&period;Redirect&lpar;&rpar;&semi; 模态） &period;</a>
					<div>
						1.弹出窗口没有最大最小化,没有滚动条,限制宽和高 this.Response.Write(&quot;&lt;script language=javascript&gt;window.open('d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVml8b.html" rel="bookmark" class="title">C&plus;&plus;：为什么unique&lowbar;ptr的Deleter是模板类型参数，而shared&lowbar;ptr的Deleter不是？</a>
					<div>
						为什么unique_ptr的Deleter是模板类型参数,而shared_ptr的Deleter不是? template &lt;class T, class D = default_delete&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmGYQM.html" rel="bookmark" class="title">https双向认证，如何在服务端获取当前请求的客户端证书id</a>
					<div>
						问题描述 RT,在https双向认证的环境下,服务端配置了客户端证书的可信任证书列表,每个客户,一个独立的客户端证书.那么当一个请求到达服务端后,在服务端的代码中,如何来获取当前请求的客户端证书是哪一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEQElM.html" rel="bookmark" class="title">kvm虚拟化学习笔记&lpar;十九&rpar;之convirt集中管理平台搭建</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://koumm.blog.51cto.com/703525/1305553 kvm虚拟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWjDEz.html" rel="bookmark" class="title">Windows 7系统激活工具推荐，激活系统只要一分钟</a>
					<div>
						相信很多用户对于安装Win7系统都巨细无遗,但很多用户又发现最常使用小马激活会因失败而告终,也许你们无法接受事实的真相,在这种情况下,我们完全可以在DOS下激活系统.请跟随笔者了解Win7激活工具怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RaWvb.html" rel="bookmark" class="title">急！！！sql绑定到datagrid中不显示（使用其他sql语句可以显示）</a>
					<div>
						问题描述 急!!!sql绑定到datagrid中不显示(使用其他sql语句可以显示) sql = &quot;SELECT a.upps as 隐患上传部门, a.istop as 一线员工人数, a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWljYGp.html" rel="bookmark" class="title">chart连接数据库读取数据，哪里出错了？</a>
					<div>
						问题描述 数据库是tb(access的),为什么语句没错误提示?调试不行呢?我开了断点?也没发现哪里错了??执行后chart里是空白的.......try{stringConStr=string.Fo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnjXJM.html" rel="bookmark" class="title">jQuery弹出框代码封装DialogHelper&lowbar;jquery</a>
					<div>
						看了jQueryUI Dialog的例子,效果还不错,就是用起来有点儿别扭,写出的代码有点拧巴,需要再封装一下!于是就有了下面这个简单的DialogHelper辅助类,因为这篇文章分享的重点是思路,所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b229AQb.html" rel="bookmark" class="title">Hbase 学习（十一）使用hive往hbase当中导入数据</a>
					<div>
						我们可以有很多方式可以把数据导入到hbase当中,比如说用map-reduce,使用TableOutputFormat这个类,但是这种方式不是最优的方式. Bulk的方式直接生成HFiles,写入到文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnoYBM.html" rel="bookmark" class="title">上传图片到sql2000</a>
					<div>
						问题描述 麻烦帮忙看看哪里有错误啊~~万分感谢啊~数据库:createtabletest1(idchar(10),picimage,);插入图片代码如下:第一个页面,inputimage.jsp:&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvnyv9M.html" rel="bookmark" class="title">如何在ubuntu下编译APK，这个APK的签名为非原生应用的签名？</a>
					<div>
						问题描述 如题,想在ubuntu下编译一个APK,因为这个APK里要用到系统的一些代码,可是我不希望这个APK的签名为系统签名,如何做到?一般情况下编好后都是在out/...system/app下,而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12KG3p.html" rel="bookmark" class="title">如何用回溯法实现控制论文提交格式！</a>
					<div>
						问题描述 把整篇论文转换为二进制文件流,然后按事先设计好论文的格式,如第一页的第一行必须是一级标题,可以把一级标题的二进制代码和论文的第一页的第一行进行判断,如果是的话,就可以,不是则标记,依此类推  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV70jlb.html" rel="bookmark" class="title">说明的比较细的php 正则学习实例&lowbar;php技巧</a>
					<div>
						&quot;^The&quot;: 匹配以 &quot;The&quot;开头的字符串;  &quot;of despair$&quot;: 匹配以 &quot;of despair&quot; 结尾 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0aExp.html" rel="bookmark" class="title">JS中的eval 为什么加括号&lowbar;javascript技巧</a>
					<div>
						eval简介 ---eval在ECMA定义中是全局对象原型的方法; ---eval接受的参数是字符串格式的js代码, 将由执行引擎(记得'高级程序设计'还是哪说过, 此时新建一个执行引擎)执行这段字符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZLAJz.html" rel="bookmark" class="title">debug-webstorm&plus;nodejs 调试 侦听端口 没有执行程序？</a>
					<div>
						问题描述 webstorm+nodejs 调试 侦听端口 没有执行程序? 装了webstorm 和nodejs 在webstorm里面可以正常run 没有任何问题 但是不能debug 只有一句Debu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0BNwp.html" rel="bookmark" class="title">C&num;如何从rtf格式内的文件读出内容，并存为xml格式啊？思路</a>
					<div>
						问题描述 这几天公司让我开发一个rtf到xml的软件,用c#,以去除垃圾代码,并把rtf里面的图片提取出来,请问我如何来实现啊?一个简单的rtf文件,里面只有几个字和一个小图片,其代码就是相当的复杂了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7Jlop.html" rel="bookmark" class="title">GWT AppEngine 保存对象序列号&period;</a>
					<div>
						想这个Google的app 都是可以先自己放一个免费的程序到服务器上面. 就是一个高兴的事情.   前几天研究了下GWT.关于做界面还是非常容易的.   java的代码想怎么写就怎么写.非常的高效率. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyK994z.html" rel="bookmark" class="title">有人搭理我不。。</a>
					<div>
						问题描述 三层架构里有一个IDAL接口层SQLServerDAL和OracleDAL都实现了它这里实现它的好处是什么啊.难道就是如果再引入AccessDAL时不用更改BLL层吗?不理解..那位明白人可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm67Nb.html" rel="bookmark" class="title">荔枝FM电台APP注销账号功能解析分享</a>
					<div>
						给各位荔枝FM电台软件的使用者们来详细的解析分享一下注销账号功能. 解析分享:   Q:荔枝FM有注销账号功能吗?要是微博.QQ.微信.手机号绑定不在一个荔枝账号上,怎么令它们绑在一起? A:目前荔枝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKNy4z.html" rel="bookmark" class="title">MFC的dll中控制资源问题</a>
					<div>
						有程序EXE和DLL,其中DLL中有1个函数用来显示对话框,被EXE调用.当EXE和DLL都为Release或Debug时,没有任何问题,但EXE为Release.DLL为Debug时,就会出错.该D ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
